attributes in attribute table don't match attribute in identify results/labels with WFS layer

2018-12-21 12:21 PM - Sebastian Brocks

Status: Closed

Priority: High

Assignee:

Category: Web Services clients/WFS

Affected QGIS version:3.5(master) Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution: fixed/implemented

Crashes QGIS or corrupts data:No Copied to github as #: 28684

Description

Using the WFS Layer "Netzknoten/Nullpunkte" on the http://inspire.brandenburg.de/services/strassennetz_wfs WFS service, I encounter

a very strange problem.

When I graphically select a feature, the attributes shown for the highlighted feature in the attribute table do not match the attributes shown

in the indentify results for that features, or the label that's (correctly) displaying one of the attributes. It's as if the attribute table shows

completely wrong data for the selected features. Is this a problem with the WFS server or with QGIS?

Associated revisions

Revision e19bf11f - 2019-02-06 10:44 AM - Even Rouault

[WFS provider] Ensure stability of QGIS FeatureId when reloading layer (fixes #20865)

Revision 4910b73f - 2019-02-06 12:07 PM - Even Rouault

[WFS provider] Ensure stability of QGIS FeatureId when reloading layer (fixes #20865)

History

#1 - 2018-12-21 01:38 PM - Alessandro Pasotti

- Affected QGIS version changed from 3.4.2 to 3.5(master)

Confirmed on master

#2 - 2018-12-21 06:11 PM - Alessandro Pasotti

Ok, this is what's happening (and it isn't good news):

- wfs keeps a spatialite cache of features that map QGIS feature ids to gml feature ids

- any time the layer is reloaded the cache is recreated and the QGIS feature id <-> gml id map changes

- when the attribute table is opened in dock mode (and populated), the QGIS application issues a canvas refresh, which in turn triggers a WFS layer reload

So, we end up with a table which was populated with data that came from a cache that has been destroyed

The root of all evil is that there are no stable feature ids from WFS.
#3 - 2018-12-21 06:55 PM - Alessandro Pasotti

btw, the issue also arises when the table is not docked and the table reload button is pushed.

#4 - 2018-12-26 07:23 PM - Giovanni Manghi

- Status changed from Open to Feedback

Does it works as expected on 2.18?

#5 - 2019-01-24 11:37 AM - Even Rouault

- Status changed from Feedback to Open

- Priority changed from Normal to High

- Category changed from Attribute table to Web Services clients/WFS

#6 - 2019-02-05 11:11 PM - Even Rouault

PR https://github.com/qgis/QGIS/pull/9105

#7 - 2019-02-06 11:53 AM - Even Rouault

- Status changed from Open to Closed

- % Done changed from 0 to 100

Applied in changeset commit:qgis|e19bf11f9edc2c40a926fa66aeff200d5fa2eb3e.

#8 - 2019-02-06 08:12 PM - Even Rouault

- Resolution set to fixed/implemented

Backported to 3.4 per https://github.com/qgis/QGIS/pull/9113
